<mat-card *ngIf="product?.title" class="product-card-item">
  <img
    *ngIf="product?.imageUrl"
    mat-card-image
    [src]="product.imageUrl"
    alt="{{ product.title }}"
  />
  <mat-card-title>{{ product.title }}</mat-card-title>
  <mat-card-subtitle>{{ product.price | currency: "USD" }}</mat-card-subtitle>
  <!-- Check if the shopping cart property does have a value at this moment
  Because this property is bind with a shopping cart observable
  and there is going to be some delay until that observable emit the shopping cart object
  During that delay this shoppingCart property is going to be undefined -->
  <mat-card-actions *ngIf="showActions && shoppingCart">
    <button
      *ngIf="shoppingCart.getQuantity(product) === 0; else updateQuantity"
      mat-button
      (click)="addToCart()"
    >
      Add to Cart
    </button>
    <ng-template #updateQuantity>
      <app-product-quantity
        [product]="product"
        [shopping-cart]="shoppingCart"
      ></app-product-quantity>
    </ng-template>
  </mat-card-actions>
</mat-card>
